(* Interface-Unit fr den Bitmap-Property-Editor      *
 *                                                    *
 * 32Bit Import-Unit                                  *
 *                                                    *
 * (c) 1995/2000 by Siegfried Penke                   *
 *                                                    *
 * Heinrich von Brentano Platz 1                      *
 * 40595 Dsseldorf                                   *
 *                                                    *
 * Germany                                            *
 *                                                    *
 * Stand 15.08.2000                                   *
 *                                                   *)

unit BmpPropEd;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Dialogs, Buttons, ComCtrls, DsgnIntf;

{ TGraphicProperty }
type
  TGraphicProperty = class (TClassProperty)
  public
    procedure Edit; override;
    function  GetAttributes: TPropertyAttributes; override;
    function  GetValue: string; override;
    procedure SetValue (const Value: string); override;
  end;


function InitDlg : boolean; stdcall                          external 'BMPPROPED.DLL' name 'InitDlg';

function DestroyDlg : boolean; stdcall                       external 'BMPPROPED.DLL' name 'DestroyDlg';

function StartDlg (hBmp : HBitmap) : hBitmap; stdcall        external 'BMPPROPED.DLL' name 'StartDlg';

function StartCachedDlg (hBmp : HBitmap) : hBitmap; stdcall  external 'BMPPROPED.DLL' name 'StartCachedDlg';

function StartGlPropEd (FBitmap : TBitmap) : boolean;

procedure Register;

implementation

var
  bmp            : TBitmap;
  HLib           : THandle;

function StartGlPropEd (FBitmap : TBitmap) : boolean;
var
  h : HBitmap;
begin
  bmp := TBitmap.Create;
  bmp.Assign (FBitmap);
  h := StartCachedDlg (bmp.Handle);  { den Dialog starten                     }
  if h <> 0 then                     { Wenn ein gltiges Bitmap vorhanden ist }
  begin
    bmp.Handle := h;                 { dem Objekt bmp zuweisen                }
    FBitmap.Assign (bmp);            { und in das FBitmap kopieren           }
  end;
  bmp.Free;
end;

{ TGraphicProperty }
procedure TGraphicProperty.Edit;
var
  FPicture : TPicture;
begin
  try
    FPicture := TPicture.Create;
    FPicture.Graphic := TBitmap (Pointer (GetOrdValue));
    StartGlPropEd (FPicture.Bitmap);
    SetOrdValue (LongInt (FPicture.Graphic));
  finally
    FPicture.Free;
  end;
end;

function TGraphicProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

function TGraphicProperty.GetValue: string;
var
  Graphic: TGraphic;
begin
  Graphic := TGraphic(GetOrdValue);
  if (Graphic = nil) or Graphic.Empty then
    Result := LoadStr (0)
  else
    Result := '(' + Graphic.ClassName + ')';
end;

procedure TGraphicProperty.SetValue (const Value : string);
begin
  if Value = '' then SetOrdValue(0);
end;

procedure Register;
begin
  RegisterPropertyEditor (TypeInfo (TBitmap), nil, '', TGraphicProperty);
end;

initialization
  try
    InitDlg;
  except end;
end.
